<template>
  <div>
    <q-drawer
      v-model="openModal"
      side="right"
      :width="600"
      :behavior="'mobile'"
      :no-swipe-backdrop="true"
      :no-swipe-open="true"
      :no-swipe-close="true"
      overlay
    >
      <q-card flat class="my-card-drawer">
        <q-form @submit.prevent="submit">
          <q-card-section class="row no-wrap items-center">
            <label class="label-modulo-consumos letras-system">
              {{ condition }} Cliente
            </label>
            <q-space />
            <label class="label-modulo-consumos letras-system">
              <q-btn dense flat icon="close" @click="openModal = false">
                <q-tooltip content-class="bg-white text-primary"
                  >Cerrar</q-tooltip
                >
              </q-btn>
            </label>
          </q-card-section>
          <q-separator></q-separator>
          <q-card-section class="q-pt-lg">
            <template v-if="loading">
              <div class="row">
                <div
                  class="col-lg-12 col-md-12 col-sm-12 col-xs-12 flex flex-center"
                >
                  <q-circular-progress
                    indeterminate
                    size="50px"
                    color="purple"
                    class="q-ma-xl"
                  />
                </div>
              </div>
            </template>
            <template v-else>
              <div class="row q-pb-xl q-mb-md">
                <div
                  class="col-lg-6 col-md-6 col-sm-12 col-xs-12 margin-fields-form"
                >
                  <label class="label-formulario" for="Nombres (*)">
                    Nombres (*)</label
                  >
                  <q-input
                    v-validate="'required'"
                    data-vv-as="nombres"
                    name="name"
                    type="text"
                    :outlined="outlined"
                    :dense="dense"
                    v-model="value.name"
                    :error-message="
                      errors && errors['name']
                        ? errors['name'][0]
                        : '' || errorsvvalidate.first('name')
                    "
                    :error="
                      errors['name'] || errorsvvalidate.first('name')
                        ? true
                        : false
                    "
                  >
                  </q-input>
                </div>

                <div
                  class="col-lg-6 col-md-6 col-sm-12 col-xs-12 margin-fields-form"
                >
                  <label class="label-formulario" for="Apellidos (*)">
                    Apellidos (*)</label
                  >
                  <q-input
                    v-validate="'required'"
                    data-vv-as="apellidos"
                    name="last_name"
                    type="text"
                    :outlined="outlined"
                    :dense="dense"
                    v-model="value.last_name"
                    :error-message="
                      errors && errors['last_name']
                        ? errors['last_name'][0]
                        : '' || errorsvvalidate.first('last_name')
                    "
                    :error="
                      errors['last_name'] || errorsvvalidate.first('last_name')
                        ? true
                        : false
                    "
                  >
                  </q-input>
                </div>

                <div
                  class="col-lg-6 col-md-6 col-sm-12 col-xs-12 margin-fields-form"
                >
                  <label class="label-formulario" for="Correo (*)">
                    Correo (*)</label
                  >
                  <q-input
                    v-validate="'email'"
                    data-vv-as="correo"
                    name="email"
                    type="text"
                    :outlined="outlined"
                    :dense="dense"
                    v-model="value.email"
                    :error-message="
                      errors && errors['email']
                        ? errors['email'][0]
                        : '' || errorsvvalidate.first('email')
                    "
                    :error="
                      errors['email'] || errorsvvalidate.first('email')
                        ? true
                        : false
                    "
                  >
                  </q-input>
                </div>

                <div
                  class="col-lg-6 col-md-6 col-sm-12 col-xs-12 margin-fields-form"
                >
                  <label class="label-formulario" for="Fecha de Nacimiento (*)">
                    Fecha de Nacimiento (*)</label
                  >

                  <VueCtkDateTimePicker
                    id="date_birthday"
                    v-model="value.date_birthday"
                    :label="'Fecha de nacimiento'"
                    output-format="DD-MM-YYYY"
                    max-date="01-01-2002"
                    formatted="ll"
                    only-date
                    color="red"
                    locale="es"
                    no-label
                    no-button-now
                    auto-close
                    no-button
                    v-validate="'required'"
                    data-vv-as="fecha de nacimiento"
                    name="date_birthday"
                    :error-message="
                      errors && errors['date_birthday']
                        ? errors['date_birthday'][0]
                        : '' || errorsvvalidate.first('date_birthday')
                    "
                    :error="
                      errors['date_birthday'] ||
                      errorsvvalidate.first('date_birthday')
                        ? true
                        : false
                    "
                  />
                </div>

                <div
                  class="col-lg-12 col-md-12 col-sm-12 col-xs-12 margin-fields-form"
                >
                  <label
                    class="label-formulario"
                    for="
                      Género (*) "
                  >
                    Género (*)
                  </label>
                  <q-select
                    options-dense
                    :outlined="outlined"
                    :dense="dense"
                    v-model="value.gender"
                    input-debounce="0"
                    :options="arrayGender"
                    option-value="id"
                    option-label="name"
                    emit-value
                    map-options
                    v-validate="'required'"
                    data-vv-as="género"
                    name="gender"
                    :error-message="
                      errors['gender']
                        ? errors['gender'][0]
                        : '' || errorsvvalidate.first('gender')
                    "
                    :error="
                      errors['gender'] || errorsvvalidate.first('gender')
                        ? true
                        : false
                    "
                  >
                    <template v-slot:no-option>
                      <q-item>
                        <q-item-section class="text-grey">
                          Sin resultados
                        </q-item-section>
                      </q-item>
                    </template>
                  </q-select>
                </div>

                <div
                  class="col-lg-12 col-md-12 col-sm-12 col-xs-12 margin-fields-form"
                >
                  <template v-if="condition == 'Nuevo'">
                    <ImageForm
                      label="Imagen"
                      variable="image"
                      pixeles="500x540"
                      peso-string="500 KB"
                      peso-number="500000"
                      :errors="errors"
                      :value.sync="value.file_image"
                      :valueParent="value.file_image"
                    ></ImageForm>
                  </template>
                  <template v-else>
                    <ImageForm
                      label="Imagen"
                      variable="image"
                      pixeles="500x540"
                      peso-string="500 KB"
                      peso-number="500000"
                      :imagesUrl="urlStorage"
                      folder="images/customers"
                      :errors="errors"
                      :value.sync="value.file_image"
                      :valueParent="value.file_image"
                    ></ImageForm>
                  </template>
                </div>
              </div>
            </template>
          </q-card-section>
          <q-card flat class="fixed-bottom padding-top-bottom-0px">
            <q-separator></q-separator>
            <q-card-section align="right">
              <div class="row">
                <div
                  class="col-lg-12 col-md-12 col-sm-12 col-xs-12 margin-fields-form"
                >
                  <div
                    class="text-subtitle1 tamano-letra-titulos-modulos letras-system"
                  >
                    <q-btn
                      unelevated
                      color="primary"
                      :label="condition == 'Nuevo' ? 'Registrar' : 'Actualizar'"
                      type="submit"
                      :loading="requestServer"
                      class="my-button-style float-right"
                    />
                    <q-btn
                      unelevated
                      color="red"
                      label="Cancelar"
                      @click="openModal = false"
                      class="my-button-style float-right q-mr-sm"
                    />
                  </div>
                </div>
              </div>
            </q-card-section>
          </q-card>
        </q-form>
      </q-card>
    </q-drawer>
  </div>
</template>
<script>
import ImageForm from "../../components/form/ImagePublic";
export default {
  components: {
    ImageForm,
  },
  props: {
    openModalParent: Boolean,
    condition: String,
    valueParent: Object,
    loading: Boolean,
  },
  data() {
    return {
      urlStorage: process.env.URL_STORAGE,
      outlined: true,
      dense: true,
      openModal: false,
      value: {},
      errors: {},
      requestServer: false,
      arrayGender: [
        {
          id: 0,
          name: "Masculino",
        },
        {
          id: 1,
          name: "Femenino",
        },
        {
          id: 2,
          name: "No definido",
        },
      ],
    };
  },
  watch: {
    openModalParent: {
      immediate: true,
      handler: function (newValue) {
        this.openModal = newValue;
      },
    },
    openModal: function (newValue, oldValue) {
      this.restoreEl(); //tengo que darle restore
      this.$emit("update:openModal", newValue);
    },
    //quiero enviar toda la info desde aqui, y no desde afuera por ello no hago update:
    valueParent: {
      immediate: true,
      handler: function (newValue) {
        if (this.openModal) {
          this.value = newValue;
        }
      },
    },
  },
  methods: {
    restoreEl() {
      this.$validator.reset();
      this.errors = {};
      this.requestServer = false;
      this.value = {};
    },
    submit() {
      this.$validator.validate().then((valid) => {
        if (valid) {
          this.requestServer = true;
          const fd = new FormData();
          if (this.value.name) {
            fd.append("name", this.value.name);
          }
          if (this.value.last_name) {
            fd.append("last_name", this.value.last_name);
          }
          if (this.value.email) {
            fd.append("email", this.value.email);
          }

          if (this.value.file_image) {
            fd.append("file_image", this.value.file_image);
          }

          if (this.value.gender) {
            fd.append("gender", this.value.gender);
          }

          if (this.value.date_birthday) {
            fd.append("date_birthday", this.value.date_birthday);
          }

          if (this.condition == "Nuevo") {
            this.$axios
              .post("api/auth/v1/customer", fd)
              .then((response) => {
                this.$q.notify({
                  color: "positive",
                  position: "bottom",
                  message: response.data.data.message,
                  icon: "check",
                });
                this.restoreEl();
                this.openModal = false;
                this.$emit("submitCreate");
              })
              .catch((error) => {
                this.requestServer = false;
                if (error.response.status === 422) {
                  this.errors = error.response.data.error || {};
                  return;
                }
              });
          } else {
            if (this.value.id) {
              fd.append("id", this.value.id);
            }
            fd.append("_method", "put");

            this.$axios
              .post("api/auth/v1/customer/" + this.value.id, fd)
              .then((response) => {
                this.$q.notify({
                  color: "positive",
                  position: "bottom",
                  message: response.data.data.message,
                  icon: "check",
                });
                this.restoreEl();
                this.openModal = false;
                this.$emit("submitEdit");
              })
              .catch((error) => {
                this.requestServer = false;
                if (error.response.status === 422) {
                  this.errors = error.response.data.error || {};
                  return;
                }
              });
          }
        }
      });
    },
  },
};
</script> 